--[[------------------------------------------------------

  xml bindings generator
  ------------------------

  This uses the 'dub' tool and Doxygen to generate the
  bindings for mimas.

  Input:  headers in 'include/xml'
  Output: cpp files in 'src/core'

--]]------------------------------------------------------
local lub = require 'lub'
local dub = require 'dub'

local ins = dub.Inspector {
  INPUT    = {
    lub.path '|include/xml',
  },
  --doc_dir = base .. '/tmp',
  --html = true,
  --keep_xml = true,
}

local binder = dub.LuaBinder()

binder:bind(ins, {
  output_directory = lub.path '|src/bind',
  -- Remove this part in included headers
  header_base = lub.path '|include',
  -- Create a single library.
  single_lib = 'xml',
  -- Open the library with require 'xml.core' (not 'xml')
  luaopen    = 'xml_core',
})
